//---------------------------------------------------------------------------
/*
ADPCM Program for Windows

 Copyright 2020 by Mark DiVecchio

    This file is part of Remote Train Control.

    Remote Train Control is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Remote Train Control is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Remote Train Control.  If not, see <http://www.gnu.org/licenses/>.

*/
// Home Page: http://www.silogic.com/trains/ADPCM.html
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <tchar.h>
//---------------------------------------------------------------------------
USEFORM("Edit_the_Scale_Factor.cpp", Edit_Scale_Factor);
USEFORM("Edit_the_Index.cpp", Edit_Index);
USEFORM("Edit_the_Softkeys.cpp", SoftKey_Editor);
USEFORM("Quilling_Whistle.cpp", Quill_Index);
USEFORM("ADPCM_Info.cpp", Splash);
USEFORM("Edit_the_Clip.cpp", Clip_Editor);
USEFORM("ADPCM_Player.cpp", ADPCM_Main);
USEUNIT("HexEdit.cpp");
USEFORM("Edit_the_Engine_Parameters.cpp", Edit_Engine_Parameters);
//---------------------------------------------------------------------------
int WINAPI _tWinMain(HINSTANCE, HINSTANCE, LPTSTR, int)
{
	try
	{
		Application->Initialize();
		Application->Title = "ADPCM Player";
		Application->CreateForm(__classid(TADPCM_Main), &ADPCM_Main);
		Application->CreateForm(__classid(TSoftKey_Editor), &SoftKey_Editor);
		Application->Run();
	}
	catch (Exception &exception)
	{
		Application->ShowException(&exception);
	}
	catch (...)
	{
		try
		{
			throw Exception("");
		}
		catch (Exception &exception)
		{
			Application->ShowException(&exception);
		}
	}
	return 0;
}
//---------------------------------------------------------------------------
