//---------------------------------------------------------------------------
/*
ADPCM Program for Windows

 Copyright 2020 by Mark DiVecchio

	This file is part of Remote Train Control.

	Remote Train Control is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Remote Train Control is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Remote Train Control.  If not, see <http://www.gnu.org/licenses/>.

*/
// Home Page: http://www.silogic.com/trains/ADPCM.html
//---------------------------------------------------------------------------
#ifndef Edit_the_ClipH
#define Edit_the_ClipH
#include <Classes.hpp>
#include <Controls.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <StdCtrls.hpp>

#include "HexEdit.h"
#include <Menus.hpp>

#define REPLACE_FROM_MTH_SOUND_FILE 0
#define REPLACE_FROM_AUDIO_FILE 1
#define ADD_FROM_MTH_SOUND_FILE 2
#define ADD_FROM_AUDIO_FILE 3
#define DELETE_CLIP_FROM_MTH_SOUND_FILE 4
#define REPLACE_CLIP_WITH_SILENCE 5

#define DATABYTEBASE 0x03
//---------------------------------------------------------------------------
class TClip_Editor : public TForm
{
__published:	// IDE-managed Components
	TRadioGroup *FormatGroup;
	TRadioGroup *OpGroup;
	TLabel *DataLabel;
	TEdit *XDataByte;
	TLabel *ClipNoLabel;
	TEdit *SourceClipNoEdit;
	TButton *DoItButton;
	TButton *CancelButton;
	TOpenDialog *OpenDialog;
	TImage *Copyright;
	TRadioGroup *SampleGroup;
	TRadioGroup *CategoryGroup;
	TLabel *Label1;
	TRadioGroup *PSGroup;
	TPanel *SoftkeyPanel;
	TCheckBox *SXSCheckBox;
	TCheckBox *SAHCheckBox;
	TCheckBox *CDxCheckBox;
	TPanel *FileNamePanel;
	TLabel *Label2;
	TButton *BrowseforFileButton;
	TLabel *EngineEEPROMSize;
	TCheckBox *QWCheckBox;
	TComboBox *MRUComboBox;
	TPopupMenu *FileNamePopupMenu;
	TMenuItem *RemoveFromList;
	TMenuItem *CleartheList1;
	void __fastcall OpGroupClick(TObject *Sender);
	void __fastcall DoItButtonClick(TObject *Sender);
	void __fastcall CancelButtonClick(TObject *Sender);
	void __fastcall BrowseforFileButtonClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormatGroupClick(TObject *Sender);
	void __fastcall CategoryGroupClick(TObject *Sender);
	void __fastcall SampleGroupClick(TObject *Sender);
	void __fastcall CopyrightClick(TObject *Sender);
	void __fastcall PSGroupClick(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall SourceClipNoEditDblClick(TObject *Sender);
	void __fastcall RemoveFromListClick(TObject *Sender);
	void __fastcall CleartheList1Click(TObject *Sender);

private:	// User declarations
	void virtual __fastcall WMDropFiles(TWMDropFiles &message);
	HANDLE hTargetFile, hSourceFile;
	String RegFileRootKey;
	THexEdit * DataByteEdit;
	void __fastcall SetDBCheckBoxes(int DB);
	void __fastcall SetORFileByte(HANDLE hFile, int Address, unsigned char Value);
	void __fastcall SetANDFileByte(HANDLE hFile, int Address, unsigned char Value);
	void __fastcall CopyBlock(HANDLE hSourceFile, HANDLE hDestFile, int StartAddr1, int EndAddr, int StartAddr2);
	void __fastcall QuillAddressFixup(HANDLE hSoundFile, int Adjustment);

public:		// User declarations
	__fastcall TClip_Editor(TComponent* Owner);
	__fastcall TClip_Editor(TComponent* Owner, int ClipNumber, String FN);
	void __fastcall ShowIt(int clip, String FN, int DB, int EAM, int PS);
	int ClipNo, EndAddrMax, FileLength;
	String SoundFileName;
	unsigned char TargetDataByte;

BEGIN_MESSAGE_MAP
	MESSAGE_HANDLER(WM_DROPFILES, TWMDropFiles, WMDropFiles);
END_MESSAGE_MAP (TForm);
};
//---------------------------------------------------------------------------
extern PACKAGE TClip_Editor *Clip_Editor;
//---------------------------------------------------------------------------
#endif
