//---------------------------------------------------------------------------
/*
ADPCM Program for Windows

 Copyright 2020 by Mark DiVecchio

    This file is part of Remote Train Control.

    Remote Train Control is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Remote Train Control is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
    along with Remote Train Control.  If not, see <http://www.gnu.org/licenses/>.

*/
// Home Page: http://www.silogic.com/trains/ADPCM.html
//---------------------------------------------------------------------------
#ifndef Edit_the_Engine_ParametersH
#define Edit_the_Engine_ParametersH
#include <Classes.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <Mask.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------

#include "HexEdit.h"

#if __BORLANDC__ < 0x720		// BCB4.0 Only
#define M_PI  3.14159265358979323846264338327950288
#endif
//---------------------------------------------------------------------------
class TEdit_Engine_Parameters : public TForm
{
__published:	// IDE-managed Components
	TImage *Copyright;
	TLabel *Label1;
	TLabel *Label5;
	TLabel *Label7;
	TLabel *Label8;
	TLabel *Label10;
	TLabel *Label11;
	TLabel *Label18;
	TLabel *Label19;
	TButton *DoItButton;
	TButton *CancelButton;
	TMaskEdit *XCountsper10feet;
	TMaskEdit *Countsperfoot;
	TMaskEdit *WheelDiameter;
	TMaskEdit *GearRatio;
	TMaskEdit *iNStripes;
	TButton *DecodeButton;
	TMaskEdit *XUnknown0405;
	TMaskEdit *XCountsperRev;
	TButton *ReloadButton;
	TLabel *Label9;
	TLabel *Label14;
	TLabel *Label6;
	TLabel *Label12;
	TLabel *Label13;
	TLabel *Label15;
	TMaskEdit *XCountsperChuff;
	TMaskEdit *XUnknown0A0B;
	TMaskEdit *ChuffsperRev;
	TMaskEdit *fClockRate;
	TLabel *EngTypeLabel;
	TLabel *Label3;
	TMaskEdit *XEngineType;
	TLabel *Label4;
	TLabel *Label16;
	TLabel *Label17;
	TLabel *Label20;
	TLabel *Label21;
	TLabel *Label2;
	TLabel *Label22;
	TLabel *Label23;
	TLabel *Label24;
	TMaskEdit *XChecksum;
	TLabel *Label25;
	TLabel *Label26;
	TLabel *Label27;
	TLabel *Label28;
	TLabel *Label29;
	TLabel *Label30;
	TLabel *Label31;
	TLabel *Label32;
	TLabel *Label33;
	TMaskEdit *XEngineNumber;
	TMaskEdit *fEngNum;
	TLabel *Label34;
	TButton *Copy256Button;
	void __fastcall DoItButtonClick(TObject *Sender);
	void __fastcall CancelButtonClick(TObject *Sender);
	void __fastcall ReloadButtonClick(TObject *Sender);
	void __fastcall CountsperfootChange(TObject *Sender);
	void __fastcall XCountsper10feetEditChange(TObject *Sender);
	void __fastcall WheelDiameterChange(TObject *Sender);
	void __fastcall Xunknown0405EditChange(TObject *Sender);
	void __fastcall GearRatioChange(TObject *Sender);
	void __fastcall XCountsperRevEditChange(TObject *Sender);
	void __fastcall ChuffsperRevChange(TObject *Sender);
	void __fastcall fClockRateChange(TObject *Sender);
	void __fastcall iNStripesChange(TObject *Sender);
	void __fastcall XEngineTypeEditChange(TObject *Sender);
	void __fastcall XUnknown0A0BChange(TObject *Sender);
	void __fastcall XCountsperChuffChange(TObject *Sender);
	void __fastcall fEngNumChange(TObject *Sender);
	void __fastcall XEngineNumberChange(TObject *Sender);
	void __fastcall Copy256ButtonClick(TObject *Sender);
    
private:	// User declarations
	String TargetFileName;
	THexEdit * XCountsper10feetEdit, * XUnknown0405Edit, * XCountsperChuffEdit, *XUnknown0A0BEdit,
    	*XCountsperRevEdit, *XEngineTypeEdit, *XChecksumEdit, *XEngineNumberEdit;
	bool ChangesMade;
	THexEdit * __fastcall CreateHexEdit(TMaskEdit * TemplateEdit, int minval, int maxval);
	int MyPSType;
	void __fastcall LoadParameters(String TargetFileName);
	void __fastcall CalcWheelDiameter(void);
    void __fastcall CalcCountsperFoot(void);
    int TabOrder;
    void __fastcall ChecksumGenerate(HANDLE hSoundFile);

public:		// User declarations
	__fastcall TEdit_Engine_Parameters(TComponent* Owner);
	__fastcall TEdit_Engine_Parameters(TComponent* Owner, String FN, int p1, int p2, int PSType);
	__fastcall ~TEdit_Engine_Parameters();
	void __fastcall ShowIt(String FN, int p1, int p2, int PSType);
};
//---------------------------------------------------------------------------
extern PACKAGE TEdit_Engine_Parameters *Edit_Engine_Parameters;
//---------------------------------------------------------------------------
#endif
