//---------------------------------------------------------------------------
/*
ADPCM Program for Windows

 Copyright 2019 by Mark DiVecchio

	This file is part of Remote Train Control.

	Remote Train Control is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Remote Train Control is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Remote Train Control.  If not, see <http://www.gnu.org/licenses/>.

*/
// Home Page: http://www.silogic.com/trains/ADPCM.html
//---------------------------------------------------------------------------
#ifndef Edit_the_IndexH
#define Edit_the_IndexH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <Mask.hpp>

//---------------------------------------------------------------------------

#include "HexEdit.h"
#include "ADPCM_Player.h"

//---------------------------------------------------------------------------
class TEdit_Index : public TForm
{
__published:	// IDE-managed Components
	TMaskEdit *XStartRepAddr;
	TMaskEdit *XEndRepAddr;
	TMaskEdit *XSMInit;
	TMaskEdit *XDataByte;
	TButton *DoItButton;
	TButton *CancelButton;
	TImage *Copyright;
	TLabel *Label1;
	TLabel *Label2;
	TLabel *Label3;
	TLabel *Label4;
	TLabel *Label5;
	TLabel *Label6;
	TMaskEdit *XStartAddr;
	TLabel *Label7;
	TMaskEdit *XEndAddr;
	TLabel *Label8;
	TCheckBox *SA_LOBit;
	TCheckBox *ERA_LOBit;
	TCheckBox *SRA_LOBit;
	TCheckBox *EA_LOBit;
	TLabel *Label9;
	void __fastcall DoItButtonClick(TObject *Sender);
	void __fastcall CancelButtonClick(TObject *Sender);

private:	// User declarations
	THexEdit * StartRepAddrEdit, * EndRepAddrEdit, * SMInitEdit, * DataByteEdit;
    THexEdit * StartAddrEdit, * EndAddrEdit;
	SFIndex IndexSound;
	String TargetFileName;
	int EndAddrMax, ClipNo;

public:		// User declarations
	__fastcall TEdit_Index(TComponent* Owner);
	__fastcall TEdit_Index(TComponent* Owner, String FN, int EAM, int clip);
	__fastcall ~TEdit_Index();
    void __fastcall ShowIt(String FN, int EAM, int clip);
};
//---------------------------------------------------------------------------
extern PACKAGE TEdit_Index *Edit_Index;
//---------------------------------------------------------------------------
#endif
 