//---------------------------------------------------------------------------
/*
ADPCM Program for Windows

 Copyright 2019 by Mark DiVecchio

    This file is part of Remote Train Control.

    Remote Train Control is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Remote Train Control is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
    along with Remote Train Control.  If not, see <http://www.gnu.org/licenses/>.

*/
// Home Page: http://www.silogic.com/trains/ADPCM.html
//---------------------------------------------------------------------------
#ifndef Edit_the_Scale_FactorH
#define Edit_the_Scale_FactorH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <Mask.hpp>

#include "HexEdit.h"

#ifndef UNICODE
#define M_PI  3.14159265358979323846264338327950288
#endif
//---------------------------------------------------------------------------
class TEdit_Scale_Factor : public TForm
{
__published:	// IDE-managed Components
	TImage *Copyright;
	TButton *DoItButton;
	TButton *CancelButton;
	TMaskEdit *XSF;
	TLabel *Label1;
	TMaskEdit *iSF;
	TLabel *Label2;
	TLabel *Label3;
	TMaskEdit *WheelDiameter;
	TLabel *Label4;
	TMaskEdit *GearRatio;
	TLabel *Label5;
	TMaskEdit *NStripes;
	TButton *DecodeButton;
	TButton *CalcScaleFactorButton;
	TButton *EncodeFromDecimalButton;
	TLabel *Label6;
	TLabel *Label7;
	TLabel *Label8;
	TLabel *Label9;
	TMaskEdit *XSpd;
	TLabel *Label10;
	TLabel *Label11;
	TButton *CalcSpeedFactorButton;
	TLabel *Label18;
	TLabel *Label19;
	TMaskEdit *XChuff;
	TButton *CalcChuffFactorButton;
	TLabel *Label12;
	TLabel *Label13;
	TButton *Button1;
	void __fastcall DoItButtonClick(TObject *Sender);
	void __fastcall CancelButtonClick(TObject *Sender);
	void __fastcall CalcScaleFactorButtonClick(TObject *Sender);
	void __fastcall DecodeButtonClick(TObject *Sender);
	void __fastcall EncodeFromDecimalButtonClick(TObject *Sender);
	void __fastcall XChange(TObject *Sender);
	void __fastcall CalcSpeedFactorButtonClick(TObject *Sender);
	void __fastcall CalcChuffFactorButtonClick(TObject *Sender);
	void __fastcall Button1Click(TObject *Sender);
private:	// User declarations
	String TargetFileName;
	THexEdit * XSFEdit, * XSpdEdit;
	THexEdit *XChuffEdit;
    bool ChangesMade;
	THexEdit * __fastcall CreateHexEdit(TMaskEdit * TemplateEdit, int minval, int maxval);
	int MyPSType;
	void __fastcall LoadFactors(String TargetFileName);
    
public:		// User declarations
	__fastcall TEdit_Scale_Factor(TComponent* Owner);
	__fastcall TEdit_Scale_Factor(TComponent* Owner, String FN, int p1, int p2, int PSType);
	__fastcall ~TEdit_Scale_Factor();
    void __fastcall ShowIt(String FN, int p1, int p2, int PSType);
};
//---------------------------------------------------------------------------
extern PACKAGE TEdit_Scale_Factor *Edit_Scale_Factor;
//---------------------------------------------------------------------------
#endif
