//---------------------------------------------------------------------------
/*
ADPCM Program for Windows

 Copyright 2019 by Mark DiVecchio

    This file is part of Remote Train Control.

    Remote Train Control is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Remote Train Control is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
    along with Remote Train Control.  If not, see <http://www.gnu.org/licenses/>.

*/
// Home Page: http://www.silogic.com/trains/ADPCM.html
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#ifndef Edit_the_SoftkeysH
#define Edit_the_SoftkeysH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TSoftKey_Editor : public TForm
{
__published:	// IDE-managed Components
	TButton *CancelButton;
	TButton *DoItButton;
	TImage *Copyright;
	TPanel *FileNamePanel;
	TLabel *Label2;
	TButton *BrowseforFileButton;
	TOpenDialog *OpenDialog;
	TGroupBox *SKGroupBox;
	TCheckBox *AuxLight3onDitch;
	TCheckBox *AuxLight2onMars;
	TCheckBox *AuxLight1onInterior;
	TCheckBox *MarkerLightonDitch;
	TCheckBox *MarkerLightonMars;
	TCheckBox *MarkerLightonInterior;
	TCheckBox *FireboxGlowonDitch;
	TCheckBox *FireboxGlowonMars;
	TCheckBox *FireboxGlowonInterior;
	TCheckBox *NumberBoardsonMarsandDitch;
	TCheckBox *NumberBoardsonDitch;
	TCheckBox *NumberBoardsonMars;
	TCheckBox *InteriorLightonDitch;
	TCheckBox *InteriorLightonMars;
	TCheckBox *RunningLightsonMarsandDitch;
	TCheckBox *TrackInspectionLightonDitch;
	TCheckBox *MarkerLight;
	TCheckBox *BeaconLight;
	TCheckBox *InteriorLightonInterior;
	TCheckBox *DitchLightMenu;
	TCheckBox *HeadlightonInterior;
	TCheckBox *MarsLightonMars;
	TLabel *Label1;
	TLabel *Label3;
	TLabel *Label4;
	TLabel *Label5;
	TGroupBox *SoundsGroupBox;
	TCheckBox *PlayWhistle;
	TCheckBox *SFS;
	TCheckBox *SmokeWhistle;
	TCheckBox *SRS;
	TCheckBox *SwingingBell;
	TCheckBox *CabChat;
	TCheckBox *SXS;
	TCheckBox *SAH;
	TCheckBox *CDX;
	TCheckBox *FCC;
	TCheckBox *SSU;
	TCheckBox *SSD;
	TCheckBox *S01;
	TCheckBox *S02;
	TCheckBox *S03;
	TCheckBox *S04;
	TCheckBox *S05;
	TCheckBox *S06;
	TCheckBox *S07;
	TCheckBox *S08;
	TCheckBox *S09;
	TCheckBox *S10;
	TCheckBox *I01;
	TCheckBox *I02;
	TCheckBox *I03;
	TCheckBox *I04;
	TCheckBox *I05;
	TCheckBox *I06;
	TCheckBox *I07;
	TCheckBox *I08;
	TLabel *Label6;
	TLabel *Label7;
	TComboBox *MRUComboBox;
	TPopupMenu *FileNamePopupMenu;
	TMenuItem *RemoveFromList;
	TMenuItem *CleartheList1;
	void __fastcall CancelButtonClick(TObject *Sender);
	void __fastcall DoItButtonClick(TObject *Sender);
	void __fastcall BrowseforFileButtonClick(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall CopyrightClick(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall CleartheList1Click(TObject *Sender);
	void __fastcall RemoveFromListClick(TObject *Sender);

private:	// User declarations
	void virtual __fastcall WMDropFiles(TWMDropFiles &message);
	bool __fastcall getBit(HANDLE hFile, int Address, unsigned char Mask);
	bool __fastcall setBit(HANDLE hFile, bool Checked, int Address, unsigned char Mask);
	void __fastcall SetCheckBoxes(void);
	String RegFileRootKey;

public:		// User declarations
	__fastcall TSoftKey_Editor(TComponent* Owner);
	void __fastcall ShowIt(String FN);

BEGIN_MESSAGE_MAP
	MESSAGE_HANDLER(WM_DROPFILES, TWMDropFiles, WMDropFiles);
END_MESSAGE_MAP (TForm);
};
//---------------------------------------------------------------------------
extern PACKAGE TSoftKey_Editor *SoftKey_Editor;
//---------------------------------------------------------------------------
#endif
