/*

BCB Hex Components: the free components for Borland C++ Builder 

Copyright 2003-20034 Jacek Szumigaj <szumi@users.sourceforge.net>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//---------------------------------------------------------------------------

#ifndef HexEditH
#define HexEditH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------
class PACKAGE THexEdit : public TCustomEdit
{
private:
   unsigned long FMinValue;
   unsigned long FMaxValue;
   unsigned long FIncrement;
    bool FOverwrite;
    int FDigits;
    bool OnChangeEventDisabled;
   unsigned long __fastcall GetValue(void);
   unsigned long __fastcall CheckValue(unsigned long NewValue);
   void __fastcall SetValue(unsigned long NewValue);
    void __fastcall SetDigits(int digits);
    void __fastcall SetMinValue(unsigned long value);
    void __fastcall SetMaxValue(unsigned long value);

   MESSAGE void __fastcall CMEnter(TWMNoParams &Message);
   MESSAGE void __fastcall CMExit(TWMNoParams &Message);
   MESSAGE void __fastcall WMPaste(TWMNoParams &Message);
   MESSAGE void __fastcall WMCut(TWMNoParams &Message);

protected:
   virtual bool __fastcall IsValidChar(Char Key);
   virtual void __fastcall Up(TObject *Sender);
   virtual void __fastcall Down(TObject *Sender);
   DYNAMIC void __fastcall KeyDown(Word &Key,  TShiftState Shift);
   DYNAMIC void __fastcall KeyPress(Char &Key);
   DYNAMIC void __fastcall Change(void);


public:
    __fastcall THexEdit(TComponent* Owner);
   //__fastcall virtual ~THexEdit(void);

__published:
   __property int Digits = {read=FDigits, write=SetDigits, default=1};
   __property bool Overwrite = {read=FOverwrite, write=FOverwrite};
   __property unsigned long Increment = {read=FIncrement, write=FIncrement, default=1};
   __property unsigned long MaxValue = {read=FMaxValue, write=SetMaxValue, nodefault};
   __property unsigned long MinValue = {read=FMinValue, write=SetMinValue, nodefault};
   __property unsigned long Value = {read=GetValue, write=SetValue, nodefault};

   __property Anchors ;
   __property AutoSelect ;
   __property AutoSize ;
   __property Color ;
   __property Constraints ;
   __property Ctl3D ;
   __property DragCursor ;
   __property DragMode ;
   __property Enabled ;
   __property Font ;
   __property MaxLength;
   __property ParentColor ;
   __property ParentCtl3D ;
   __property ParentFont ;
   __property ParentShowHint ;
   __property PopupMenu ;
   __property ReadOnly ;
   __property ShowHint ;
   __property TabOrder ;
   __property TabStop ;
   __property Visible ;
   __property OnChange ;
   __property OnClick ;
   __property OnDblClick ;
   __property OnDragDrop ;
   __property OnDragOver ;
   __property OnEndDrag ;
   __property OnEnter ;
   __property OnExit ;
   __property OnKeyDown ;
   __property OnKeyPress ;
   __property OnKeyUp ;
   __property OnMouseDown ;
   __property OnMouseMove ;
   __property OnMouseUp ;
   __property OnStartDrag ;

BEGIN_MESSAGE_MAP
	VCL_MESSAGE_HANDLER(CM_ENTER, TWMNoParams, CMEnter);
	VCL_MESSAGE_HANDLER(CM_EXIT, TWMNoParams, CMExit);
    VCL_MESSAGE_HANDLER(WM_PASTE, TWMNoParams, WMPaste);
    VCL_MESSAGE_HANDLER(WM_CUT, TWMNoParams, WMCut);
END_MESSAGE_MAP(TCustomEdit);

protected:

public:

__published:

};
//---------------------------------------------------------------------------
#endif
