//---------------------------------------------------------------------------
/*
ADPCM Program for Windowss

 Copyright 2015 by Mark DiVecchio

    This file is part of Remote Train Control.

    Remote Train Control is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Remote Train Control is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Remote Train Control.  If not, see <http://www.gnu.org/licenses/>.

*/
// Home Page: http://www.silogic.com/trains/ADPCM.html
//---------------------------------------------------------------------------
#ifndef Quilling_WhistleH
#define Quilling_WhistleH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <Grids.hpp>
#include <Menus.hpp>

#define QDIGITSTODISPLAY 6 		// number of digits to display in address fields
#define QOFFSETDIGITSTODISPLAY 4	// number of digits to display in offset field
#define QDATADIGITSTODISPLAY 8	// number of digits to display in Data Word Field

//---------------------------------------------------------------------------
class TQuill_Index : public TForm
{
__published:	// IDE-managed Components
	TPanel *FileNamePanel;
	TLabel *Label3;
	TEdit *ClipEdit;
	TEdit *FileEdit;
	TPanel *AnalyzePanel;
	TButton *AnalyzeButton;
	TButton *ClearButton;
	TStringGrid *StringGrid1;
	TPanel *ButtonPanel;
	TLabel *Label6;
	TImage *Copyright;
	TButton *RestartButton;
	TButton *PauseButton;
	TButton *PlayClipButton;
	TButton *StopButton1;
	TButton *ExitButton;
	TButton *ExportOneCliptomp3;
	TPopupMenu *IndexPopupMenu;
	TMenuItem *CopyRowtoClipboard;
	TMenuItem *CopyClipIndextoClipboard1;
	TMenuItem *DecodeandPlayClip;
	TMenuItem *PlayRepeatingSegmentofClip1;
	TMenuItem *ToggleOffsetClipNo;
	TMenuItem *ClipInfo;
	TMenuItem *DumpClip1;
	TMenuItem *DumpEntireCliptoDisk;
	TMenuItem *DumpRepeatingSegmentofCliptoDisk;
	TMenuItem *Export1Cliptomp3;
	TMenuItem *ExportAllClipstomp3;
	TMenuItem *N1;
	TMenuItem *EditIndexnewversion1;
	TMenuItem *CopyIndex;
	TMenuItem *ClearthisIndex;
	TMenuItem *N3;
	TMenuItem *AboutADPCM;
	TMemo *MemoBuffer;
	void __fastcall ClearButtonClick(TObject *Sender);
	void __fastcall ExitButtonClick(TObject *Sender);
	void __fastcall AnalyzeButtonClick(TObject *Sender);
	void __fastcall StringGrid1FixedCellClick(TObject *Sender, int ACol, int ARow);
	void __fastcall StringGrid1Click(TObject *Sender);
	void __fastcall StringGrid1DrawCell(TObject *Sender, int ACol, int ARow, TRect &Rect,
          TGridDrawState State);
	void __fastcall PlayClipButtonClick(TObject *Sender);
	void __fastcall StringGrid1DblClick(TObject *Sender);
	void __fastcall StringGrid1KeyPress(TObject *Sender, System::WideChar &Key);
	void __fastcall StringGrid1SelectCell(TObject *Sender, int ACol, int ARow, bool &CanSelect);
	void __fastcall ToggleOffsetClipNoClick(TObject *Sender);
	void __fastcall PauseButtonClick(TObject *Sender);
	void __fastcall RestartButtonClick(TObject *Sender);
	void __fastcall AboutADPCMClick(TObject *Sender);
	void __fastcall CopyRowtoClipboardClick(TObject *Sender);
	void __fastcall CopyClipIndextoClipboard1Click(TObject *Sender);
	void __fastcall ClearthisIndexClick(TObject *Sender);
	void __fastcall CopyIndexClick(TObject *Sender);
	void __fastcall ClipInfoClick(TObject *Sender);
	void __fastcall Export1Cliptomp3Click(TObject *Sender);
	void __fastcall ExportAllClipstomp3Click(TObject *Sender);
	void __fastcall StopButton1Click(TObject *Sender);
	void __fastcall DumpEntireCliptoDiskClick(TObject *Sender);



private:	// User declarations
	bool Decoded;
	int ClipNo;
	bool IndexFormat;
	void __fastcall ExportClip(int clipNo);
	bool ExportOneClipFlag;

public:		// User declarations
	__fastcall TQuill_Index(TComponent* Owner);
	__fastcall TQuill_Index(TComponent* Owner, String FN, int clip);
	void __fastcall ClearStringGrid(void);
	void __fastcall ShowIt(String FN, int clip);
};
//---------------------------------------------------------------------------
extern PACKAGE TQuill_Index *Quill_Index;
//---------------------------------------------------------------------------
#endif
